> For the complete documentation index, see [llms.txt](https://docs.optitrack.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.optitrack.com/v3.0/developer-tools/natnet-sdk/natnet-migration-to-natnet-3.0-libraries.md).

# NatNet: Migration to NatNet 3.0 libraries

This page is created to guide help users migrating their NatNet projects onto NatNet 3.0 libraries.

## Statically Linked Libraries

NatNet 3.0 no longer allows static linking of the libraries. If a NatNet project was utilizing NatNetLibStatic.lib to accomplish static linking, you will need to make changes to the project configurations, so that it links dynamically instead.

{% hint style="info" %}
*This is only an example. Required configuration changes may be different depending on how the projects were setup.*

**Visual Studio Example**

* **Project Settings → Configuration Properties → C/C++ → Preprocessor Definitions:** Add "NATNATLIB\_IMPORTS"
* **Project Settings → Configuration Properties → Linker → Input → Additional Dependencies:** Change "NatNetLibStatic.lib" to "NatNetLib.lib"
* **Project Settings → Configuration Properties → Linker → General:** Make sure the additional library directories includes the directory where the library files are locate.
  {% endhint %}

## Rigid Body Marker Data

In NatNet 3.0, the structure of Rigid Body descriptions and Rigid Body frame data has been slightly modified. The sRigidBodyData:Markers member has been removed, and instead, the Rigid Body description (sRigidBodyDescription) now includes the expected Rigid Body marker positions in respect to the corresponding RB orientation axis.

Per-frame positions of Rigid Body markers have to be derived using the Rigid Body tracking data and the expected Rigid Body markers positions included in the description packet.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.optitrack.com/v3.0/developer-tools/natnet-sdk/natnet-migration-to-natnet-3.0-libraries.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
